#lang racket

(require "mauxb.rkt")

;;;; 7. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 5.4.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - metainterpreter programovacieho jazyka LISP,
;;;; - rekurzívne nerozhodnuteľné problémy.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory maux*.rkt obsahujú definície pomocných funkcií a predikátov. 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 0
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 10
;;;; Odovzdať do 17.4.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define nil null)

;;; Kapitola. Čiastočne rekurzívne funkcie.

;;; Sekcia. Univerzálna funkcia pre čiastočne rekurzívne funkcie.

;;; Podsekcia. Aritmetizácia rekurzívnych termov a funkčných symbolov.

;; [Lisp] Pozri modul v súbore mauxb.rkt.

;;; Sekcia. Enumerácia čiastočne rekurzívnych funkcií.

;; Enumeračná funkcia unárnych čiastočne rekurzívnych funkcií.
;;   Notácia: {e}{x)
;;   Jej graf: {e}(x) ≃ y

;;; Sekcia. Rekurzívne indexy.

;; Úloha. Zostrojte rekurzívne indexy pre tieto identity λx.x, λxy.x a λxy.y.

(define ⌜λx.x⌝ ...)
(define ⌜λxy.x⌝ ...)
(define ⌜λxy.y⌝ ...)

;; (and (FUNCTION? ⌜λx.x⌝) (FUNCTION? ⌜λxy.x⌝) (FUNCTION? ⌜λxy.y⌝))
;; (and (recursive-function-symbol? 1 ⌜λx.x⌝) (recursive-function-symbol? 2 ⌜λxy.x⌝) (recursive-function-symbol? 2 ⌜λxy.y⌝))

;; Úloha. Zostrojte program pre funkciu xc1(m) takú, že platí:
;;   {xc1(m)}(x) ≃ m

(define (xc1 m) ...)

;; (query (λ (m) (FUNCTION? (xc1 m))) 0 10)
;; (query (λ (m) (recursive-function-symbol? 1 (xc1 m))) 0 10)

;; Úloha. Zostrojte program pre funkciu xcomposition(e1,e2) takú, že platí:
;;   {xcomposition(e1,e2)}(x) ≃ {e2}({e1}(x))

(define (xcomposition e1 e2) ...)

;; Úloha. Zostrojte program pre funkciu xcomposition^1_2(e,e1,e2) takú, že platí:
;;   {xcomposition^1_2(e,e1,e2)}(x) ≃ {e}({e1}(x),{e2}(x))

(define (xcomposition^1_2 e e1 e2) ...)

;;; Sekcia. Rekurzívne nerozhodnuteľné problémy.

;; Aritmetizácia problému zastavenia pre unárne čiastočne rekurzívne funkcie.
;;   W(e,x) ↔ ∃y {e}(x) ≃ y

;; Veta. Predikát W(e,x) nie je rekurzívny.
;; Dôsledok. Problém zastavenia je rekurzívne nerozhodnuteľný.

;; Veta. Predikát ¬W(e,x) nie je rekurzívny.
;; Dôsledok. Komplement problému zastavenia je rekurzívne nerozhodnuteľný.

;; (projekt)
;; Úloha. Uvažujme predikát definovaný vzťahom
;;   input0-problem?(e) ↔ ∃y {e}(0) ≃ y
;; Zostrojte program pre funkciu W->input0-problem(e,x) takú, že platí
;;   W(e,x) ↔ input0-problem?(W->input0-problem(e,x))
;; Dôsledok. Predikát input0-problem?(e) nie je rekurzívny.
;; Dôsledok. Problém zastavenia pre vstup 0 je rekurzívne nerozhodnuteľný.

(define (W->input0-problem e x) ...)

;; (projekt)
;; Úloha. Uvažujme predikát definovaný vzťahom
;;   input1-problem?(e) ↔ ∃y {e}(1) ≃ y
;; Zostrojte program pre funkciu W->input1-problem(e,x) takú, že platí
;;   W(e,x) ↔ input1-problem?(W->input1-problem(e,x))
;; Dôsledok. Predikát input1-problem?(e) nie je rekurzívny.
;; Dôsledok. Problém zastavenia pre vstup 1 je rekurzívne nerozhodnuteľný.

(define (W->input1-problem e x) ...)

;; (projekt)
;; Úloha. Uvažujme predikát definovaný vzťahom
;;   output-problem?(y,e) ↔ ∃x {e}(x) ≃ y
;; Zostrojte programy pre funkcie W->output-problem1(e,x) a
;; W->output-problem2(e,x) také, že platí
;;   W(e,x) ↔ output-problem?(W->output-problem1(e,x),W->output-problem2(e,x))
;; Dôsledok. Predikát output-problem?(y,e) nie je rekurzívny.
;; Dôsledok. Problém výstupu je rekurzívne nerozhodnuteľný.

(define (W->output-problem1 e x) ...)
(define (W->output-problem2 e x) ...)

;; (projekt)
;; Úloha. Uvažujme predikát definovaný vzťahom
;;   output0-problem?(e) ↔ ∃x {e}(x) ≃ 0
;; Zostrojte programy pre funkciu W->output0-problem(e,x) takú, že platí
;;   W(e,x) ↔ output0-problem?(W->output0-problem(e,x))
;; Dôsledok. Predikát output0-problem?(e) nie je rekurzívny.
;; Dôsledok. Problém výstupu pre 0 je rekurzívne nerozhodnuteľný.

(define (W->output0-problem e x) ...)

;; (projekt)
;; Úloha. Uvažujme predikát definovaný vzťahom
;;   output1-problem?(e) ↔ ∃x {e}(x) ≃ 1
;; Zostrojte programy pre funkciu W->output1-problem(e,x) takú, že platí
;;   W(e,x) ↔ output1-problem?(W->output1-problem(e,x))
;; Dôsledok. Predikát output1-problem?(e) nie je rekurzívny.
;; Dôsledok. Problém výstupu pre 1 je rekurzívne nerozhodnuteľný.

(define (W->output1-problem e x) ...)

;; (projekt)
;; Úloha. Uvažujme predikát definovaný vzťahom
;;   equivalence-problem?(e1,e2) ↔ ∀x∀y({e1}(x) ≃ y ↔ {e2}(x) ≃ y)
;; Zostrojte programy pre funkcie W->equivalence-problem1(e,x) a
;; W->equivalence-problem2(e,x) také, že platí
;;   W(e,x) ↔ equivalence-problem?(W->equivalence-problem1(e,x),W->equivalence-problem2(e,x))
;; Dôsledok. Predikát equivalence-problem?(e1,e2) nie je rekurzívny.
;; Dôsledok. Problém ekvivalencie programov je rekurzívne nerozhodnuteľný.

(define (W->equivalence-problem1 e x) ...)
(define (W->equivalence-problem2 e x) ...)

;; (projekt)
;; Úloha. Uvažujme predikát definovaný vzťahom
;;   constant-function-problem?(e) ↔ ∃y∀x {e}(x) ≃ y
;; Zostrojte programy pre funkciu W->constant-function-problem(e,x) takú, že platí
;;   W(e,x) ↔ constant-function-problem?(W->constant-function-problem(e,x))
;; Dôsledok. Predikát constant-function-problem?(e) nie je rekurzívny.
;; Dôsledok. Problém, či program počíta konštantnú funkciu, je rekurzívne nerozhodnuteľný.

(define (W->constant-function-problem e x) ...)

;; (projekt)
;; Úloha. Uvažujme predikát definovaný vzťahom
;;   constant0-function-problem?(e) ↔ ∀x {e}(x) ≃ 0
;; Zostrojte programy pre funkciu W->constant0-function-problem(e,x) takú, že platí
;;   W(e,x) ↔ constant0-function-problem?(W->constant0-function-problem(e,x))
;; Dôsledok. Predikát constant0-function-problem?(e) nie je rekurzívny.
;; Dôsledok. Problém, či program počíta konštantnú funkciu λx.0, je rekurzívne nerozhodnuteľný.

(define (W->constant0-function-problem e x) ...)

;; (projekt)
;; Úloha. Uvažujme predikát definovaný vzťahom
;;   constant1-function-problem?(e) ↔ ∀x {e}(x) ≃ 1
;; Zostrojte programy pre funkciu W->constant1-function-problem(e,x) takú, že platí
;;   W(e,x) ↔ constant1-function-problem?(W->constant1-function-problem(e,x))
;; Dôsledok. Predikát constant1-function-problem?(e) nie je rekurzívny.
;; Dôsledok. Problém, či program počíta konštantnú funkciu λx.1, je rekurzívne nerozhodnuteľný.

(define (W->constant1-function-problem e x) ...)

;; (projekt)
;; Úloha. Uvažujme predikát definovaný vzťahom
;;   uniform-halting-problem?(e) ↔ ∀x∃y {e}(x) ≃ y
;; Zostrojte program pre funkciu W->uniform-halting-problem(e,x) takú, že platí
;;   W(e,x) ↔ uniform-halting-problem?(W->uniform-halting-problem(e,x))
;; Dôsledok. Predikát uniform-halting-problem?(e) nie je rekurzívny.
;; Dôsledok. Uniformný problém zastavenia je rekurzívne nerozhodnuteľný.

(define (W->uniform-halting-problem e x) ...)

;; (projekt)
;; Úloha. Uvažujme predikát definovaný vzťahom
;;   divergence-problem?(e) ↔ ¬∃x∃y {e}(x) ≃ y
;; Zostrojte program pre funkciu notW->divergence-problem(e,x) takú, že platí
;;   ¬W(e,x) ↔ divergence-problem?(notW->divergence-problem(e,x))
;; Dôsledok. Predikát divergence-problem?(e) nie je rekurzívny.
;; Dôsledok. Problém divergencie programov je rekurzívne nerozhodnuteľný.

(define (notW->divergence-problem e x) ...)

;; (projekt)
;; Úloha. Uvažujme predikát definovaný vzťahom
;;   divergence0-problem?(e) ↔ ¬∃y {e}(0) ≃ y
;; Zostrojte program pre funkciu notW->divergence0-problem(e,x) takú, že platí
;;   ¬W(e,x) ↔ divergence0-problem?(notW->divergence0-problem(e,x))
;; Dôsledok. Predikát divergence0-problem?(e) nie je rekurzívny.
;; Dôsledok. Problém divergencie programov pre vstup 0 je rekurzívne nerozhodnuteľný.

(define (notW->divergence0-problem e x) ...)
